//+------------------------------------------------------------------+
//|																								 Dance_trail.0.mq4 |
//|																		 Copyright  2009, Big Tent. |
//|																																	|
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Big Tent Dancing and Singing Incorporated!"
#property link			""

extern	bool	Trail_before_profit		=	false;
extern   int   Trail_after_Pips_profit =  6;
extern	bool	Auto_SBE_plus_one			=	true;
extern	int	SBE_plus_one				=	15;
extern	int	Pips_buffer					=	1;

double	Spread, Pips, Long_stop, Short_stop,Stop_price;
int		i,j,Ticket_num;
datetime	Current_bar;
string	Trade_type;


double GetSpread()
	{
	return (MarketInfo(Symbol(),MODE_SPREAD)*Point);
	//return (Ask - Bid);
	}

//+------------------------------------------------------------------+
//| expert initialization function																	 |
//+------------------------------------------------------------------+
int init()
	{
//----

   Pips = 1*Point;
   if(Digits==3||Digits==5)Pips=10*Point;
	Spread = GetSpread();
	Long_stop = 0;
	Short_stop = 0;
	//Long_stop = Low[1] - Pips_buffer;
	//Short_stop = High[1] + Spread + Pips_buffer*Pips;
	Current_bar = Time[0];

//----
	 return(0);
	}
//+------------------------------------------------------------------+
//| expert deinitialization function																 |
//+------------------------------------------------------------------+
int deinit()
	{
//----
	 
//----
	 return(0);
	}
//+------------------------------------------------------------------+
//| expert start function																						|
//+------------------------------------------------------------------+
int start()
{
//----

   Pips = 1*Point;
   if(Digits==3||Digits==5)Pips=10*Point;


//Check for new Bar and execute the folowing only on new bar

if(Long_stop == 0) Long_stop = Low[1] - Pips_buffer*Pips;
if(Short_stop == 0) Short_stop = High[1] + Spread + Pips_buffer*Pips;

if(Time[0] != Current_bar)
	{
	Current_bar = Time[0];
	Spread = GetSpread();
	Long_stop = Low[1] - Pips_buffer*Pips;
	Short_stop = High[1] + Spread + Pips_buffer*Pips;	
	}

//+---------------------------------------------------------+
//|																			|
//|	Check to see if we have a trade. If so, set stop		|
//|																			|
//+---------------------------------------------------------+

if (OrdersTotal() != 0)
	 {
	 for(i=0;i<=OrdersTotal();i++)
			{
			OrderSelect(i,SELECT_BY_POS);
				Ticket_num = OrderTicket();
				if(Ticket_num != 0 && OrderSymbol() == Symbol())
				 	{
				 	Stop_price = OrderStopLoss();
				 	
					if (OrderType() == OP_BUY)
						{
						//Print("Processing Ticket ", Ticket_num," OrderStopLoss is ",OrderStopLoss()," Long stop is ",Long_stop);
						if(OrderStopLoss() < Long_stop)
							{
							if(!Trail_before_profit && Bid < OrderOpenPrice() + Trail_after_Pips_profit*Pips) 
						   	{
						   	//Print("Debug 1: OrderStoploss = ",OrderStopLoss(),"Bid =" ,Bid, " Trail start level = ",OrderOpenPrice() + Trail_after_Pips_profit*Pips);
						   	//Print("Long trade leaving SL alone as Trail_before_profit not reached. Profit =", DoubleToStr((Bid - OrderOpenPrice())/Pips,1));
						   	Stop_price = OrderStopLoss();
						      }
							else if(Long_stop > OrderStopLoss()) 
						   	{
						   	//Print("Debug 2: OrderStoploss = ",OrderStopLoss(),"Long_stop = ",Long_stop, "Bid =" ,Bid, " Trail start level = ",OrderOpenPrice() + Trail_after_Pips_profit*Pips);
						   	//Print("Long trade - moving stop to ",Long_stop,"Profit =", DoubleToStr((Bid - OrderOpenPrice())/Pips,1));
						   	Stop_price = Long_stop;
						   	}
							}
						if(Auto_SBE_plus_one && OrderStopLoss() < OrderOpenPrice() + (1*Pips))
						   {
						   //Print("Profit is ", DoubleToStr((Bid - OrderOpenPrice())/Pips,1), " SBE+1 level is ",DoubleToStr((SBE_plus_one*Pips - OrderOpenPrice())/Pips,1));
						   if(Bid >= OrderOpenPrice() + SBE_plus_one*Pips) 
						      {
						      //Print("SBE info: OrderOpenPrice() = ",OrderOpenPrice()," SBE+1 = ",SBE_plus_one," Bid = ", Bid, "SBE+1 level is ",OrderOpenPrice() + SBE_plus_one*Pips);
						      //Print("Moving Stop to SBE+1. Profit =", DoubleToStr((Bid - OrderOpenPrice())/Pips,1));
						      Stop_price = OrderOpenPrice() + 1*Pips;
						      }
						   }
						}
					if (OrderType() == OP_SELL)
						{
						if(OrderStopLoss() > Long_stop) 
							{
							if(!Trail_before_profit && Ask > OrderOpenPrice() - Trail_after_Pips_profit*Pips) 
						   	{
						   	//Print("Debug 3: OrderStoploss = ",OrderStopLoss(),"Ask =" ,Ask, " Trail start level = ",OrderOpenPrice() - Trail_after_Pips_profit*Pips);
						   	//Print("Short trade leaving SL alone as Trail_before_profit not reached. Profit =", DoubleToStr((OrderOpenPrice() - Ask)/Pips,1));
						   	Stop_price = OrderStopLoss();
						   	}
							else if(Short_stop < OrderStopLoss())
						   	{
						   	//Print("Debug 4: OrderStoploss = ",OrderStopLoss(),"Short_stop = ",Short_stop, "Ask =" ,Ask, " Trail start level = ",OrderOpenPrice() + Trail_after_Pips_profit*Pips);
						   	//Print("Short trade - moving stop to ",Short_stop,"Profit =", DoubleToStr((OrderOpenPrice() - Ask)/Pips,1));
						   	Stop_price = Short_stop;
						   	}
							}
						if(Auto_SBE_plus_one && OrderStopLoss() > OrderOpenPrice() - 1*Pips)
						   {
						   //Print("Profit is ", DoubleToStr((OrderOpenPrice() - Ask)/Pips,1), " SBE+1 level is ",DoubleToStr((OrderOpenPrice() - SBE_plus_one*Pips)/Pips,1));
						   if(Bid <= OrderOpenPrice() - SBE_plus_one*Pips)
						      {
						      //Print("SBE info: OrderOpenPrice() = ",OrderOpenPrice()," SBE+1 = ",SBE_plus_one," Ask = ", Ask, "SBE+1 level is ",OrderOpenPrice() - SBE_plus_one*Pips);
						      //Print("Moving Stop to SBE+1. Profit = ", DoubleToStr((OrderOpenPrice() - Ask)/Pips,1));
						      Stop_price = OrderOpenPrice() - 1*Pips;
						  	   }
							}
						}
					
					if (Stop_price != OrderStopLoss()) OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Stop_price,Digits),OrderTakeProfit(),0,CLR_NONE);
					}
			}

		}



return(0);
}


//+-----------End------------+


